var Example = cc.PhysicsSprite.extend({
    ctor : function(target, pos, image){
        this._super(image);

        this.body = new cp.Body(1, cp.momentForBox(1,200,200));    //质量，宽，高
        this.body.setPos(pos);

        this.shape = new cp.BoxShape(this.body, 200,200);
        this.shape.setCollisionType(10);

        target.space.addShape(this.shape);
        target.space.addBody(this.body);
        this.setBody(this.body);

        this.setPosition(pos);
        target.addChild(this);

        return this;
    },

    update : function(dt){

    },
    destroy:function () {

    }
});

//在Prop上增加了物理功能
var SuperProp = cc.PhysicsSprite.extend({
    _parent:null,
    deltaX:null,
    deltaY:null,
    proptype:null,
    configplay:null,
    ctor:function(currenthero,proptype,path,name,parent,mass,width,height,isnormal){
        this._super(path);
        this.currenthero = currenthero;
        this.calcConfigplay();
        this.isNormal = isnormal;
        this._parent = parent;
        this.name = name;
        this.deltaX = 0;
        this.deltaY = 0;
        this.mass = mass;
        this.width_ = width;
        this.height_ = height;
        this.proptype = proptype;
        this.couldTouch = true;
        this.calcDeltaParentPos();


        this.body = new cp.Body(1, cp.momentForBox(this.mass,this.width_,this.height_));    //质量，宽，高
        this.body.datas = this;
        this.body.setPos(this.width_/2,this.height_/2);


        this.shape = new cp.BoxShape(this.body, this.width_, this.height_);
        this.shape.setElasticity(0);             //设置弹性系数
        this.shape.setFriction(0);               //设置摩擦力
        this.shape.setCollisionType(1001);

        this.setGropAndLayers(this.proptype);

        this.setBody(this.body);

        this.addTouchListener();
    },
    calcConfigplay:function(){
        switch (this.currenthero){
            case "monkey":
                this.configplay = Config_Play.monkey;
                break;
            case "rabbit":
                this.configplay = Config_Play.rabbit;
                break;
            case "dog":
                this.configplay = Config_Play.dog;
                break;
            case "duck":
                this.configplay = Config_Play.duck;
                break;
            default:
                break;
        }
    },
    allowEmulate:function(){
        this._parent.space.addBody(this.body);
        this._parent.space.addShape(this.shape);
    },
    cancelEmulate:function(){
        this.removeShapeAndBody();
    },
    calcDeltaParentPos:function(currenthero){
        switch (currenthero){
            case "monkey" :
                this.deltaParentPos = Config_Play.monkey.hero_position;
                break;
            case "duck" :
                this.deltaParentPos = Config_Play.duck.hero_position;
                break;
            case "rabbit" :
                this.deltaParentPos = Config_Play.rabbit.hero_position;
                break;
            case "dog" :
                this.deltaParentPos = Config_Play.dog.hero_position;
                break;
            default :
                this.deltaParentPos = cc.p(GW2,GH2);
                break;
        }
    },
    setGropAndLayers:function(proptype){
        switch(proptype){
            case Config_Play.propType.cloth :
                this.shape.group = 1;
                // this.shape.layers = 0x01;
                this.shape.setLayers(0x01);
                // mylog("我的形状分组是0x01,我是衣服");
                break;
            case Config_Play.propType.glass :
                this.shape.group = 1;
                // this.shape.layers = 0x01;
                this.shape.setLayers(0x02);
                // mylog("我的形状分组是0x02,我是眼镜");
                break;
            case Config_Play.propType.hat :
                this.shape.group = 1;
                // this.shape.layers = 0x01;
                this.shape.setLayers(0x04);
                // mylog("我的形状分组是0x04,我是帽子");
                break;
            default :
                break;
        }
    },
    onTouchBegan: function (touch, event) {
        var target = event.getCurrentTarget();
        var locationInNode = target.convertToNodeSpace(touch.getLocation());
        var s = target.getContentSize();
        var rect = cc.rect(0, 0, s.width, s.height);
        var self = this;
        if (cc.rectContainsPoint(rect, locationInNode) && this.couldTouch) {
            cc.log("触摸开始");
            ddPlayEffect("effect","res/K/audio/game/choose.mp3",false);
            this.setGlobalZOrder(100);
            return true;
        }
        return false;
    },
    onTouchMoved:function(touch,event) {
        if(touch.getLocation().x >=-100 && touch.getLocation().x <= cc.winSize.width+100 && touch.getLocation().y >= -100 && touch.getLocation().y <= cc.winSize.height+100) {
            var delta = touch.getDelta();
            this.x += delta.x;
            this.y += delta.y;
            this.deltaX = delta.x;
            this.deltaY = delta.y;
        }
    },
    onTouchEnded:function(touch,event){
        var target = event.getCurrentTarget();
        var s = target.getContentSize();
        var rect = cc.rect(0, 0, s.width, s.height);
        cc.log("Prop的当前位置 : " + "( " + parseInt(this.x) + ", " + parseInt(this.y) + " )");
        cc.log("Prop的ContentSize : " + "< " + this.getContentSize().width +" , " + this.getContentSize().height +" >");
        cc.log("Prop的当前TextureRect : " + "( " + parseInt(this.getTextureRect().x) + ", " + parseInt(this.getTextureRect().y) + " )<" + parseInt(this.getTextureRect().width) + ", " + parseInt(this.getTextureRect().height) + " >");
        cc.log("Prop的当前BoundingBox : " + "( " + parseInt(this.getBoundingBox().x) + ", " + parseInt(this.getBoundingBox().y) + " )<" + parseInt(this.getBoundingBox().width) + ", " + parseInt(this.getBoundingBox().height) + " >");
        this.prop_ok_pos = null;
        switch(this.proptype){
            case Config_Play.propType.cloth :
                this.prop_ok_pos = this.configplay.prop_ok_position.cloth;
                break;
            case Config_Play.propType.glass :
                this.prop_ok_pos = this.configplay.prop_ok_position.glass;
                break;
            case Config_Play.propType.hat :
                this.prop_ok_pos = this.configplay.prop_ok_position.hat;
                break;
            default :
                cc.log("type not found");
                break;
        }
        switch (this.getPropType(target.name)) {
            case "cloth" :{
                if (this.isCollided(this._parent.hero_cloth,this)) {
                    this.setPosition(this.prop_ok_pos);
                    this.setVisible(false);
                    if(this.currenthero == "duck") {
                        this._parent.hero_cloth_index = findSkinIndex_string_duck("cloth", this.getName().replace("cloth_", ""));
                    }else{
                        this._parent.hero_cloth_index = findSkinIndex_string("cloth", this.getName().replace("cloth_", ""));
                    }
                    cc.log("当前的衣服是 " + Config_Play.cloth.names[revMapStr(this._parent.hero_cloth_index)]);
                    this._parent.setSkin();
                    this.checkCheerUp(this._parent.getHatIndexString(),this._parent.getGlassIndexString(),this._parent.getClothIndexString());
                    // ddStopAllEffects();
                    ddPlayEffect("effect","res/K/audio/game/dressyes.mp3",false);
                    if(this.currenthero == "duck"){
                        this._parent.hero_cloth_flag_have = false;
                        if(!this._parent.hero_cloth_flag_have) {
                            this._parent.propManagerCloth.gotoNextAndCreateAProp(Config_Play.clothduck.names[revMapStr(this._parent.hero_cloth_index)]);
                            this._parent.hero_cloth_flag_have = true;
                        }
                        this._parent.hero_cloth_remove.setEnable(true);
                    }else{
                        this._parent.hero_cloth_flag_have = false;
                        if(!this._parent.hero_cloth_flag_have) {
                            this._parent.propManagerCloth.gotoNextAndCreateAProp(Config_Play.cloth.names[revMapStr(this._parent.hero_cloth_index)]);
                            this._parent.hero_cloth_flag_have = true;
                        }
                        this._parent.hero_cloth_remove.setEnable(true);
                    }


                    if(this.currenthero == "duck") {
                        var temp_a1 = Config_Play.hatduck.names[revMapStr(this._parent.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glassduck.names[revMapStr(this._parent.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.clothduck.names[revMapStr(this._parent.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }else{
                        var temp_a1 = Config_Play.hat.names[revMapStr(this._parent.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glass.names[revMapStr(this._parent.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.cloth.names[revMapStr(this._parent.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }

                    var a = temp_a1 + temp_a2 + temp_a3;
                    var b = this._parent.hero_hat_grade;
                    var c = this._parent.hero_glass_grade;
                    var d = 0;
                    var e = 0;
                    var ind = 0;
                    for(var i = 0;i < this.configplay.hate.cloth.length;i ++,ind ++){
                        if("cloth_"+this.configplay.hate.cloth[i] == target.name){
                            break;
                        }
                    }
                    if(ind == this.configplay.hate.cloth.length){
                        e = this._parent.latestGrade = 1;
                        d = this._parent.hero_cloth_grade = 1;
                    }else{
                        e = this._parent.latestGrade = -1;
                        d = this._parent.hero_cloth_grade = -1;
                    }
                    this._parent.updateAndHandleUp(a,b,c,d,e);

                    this.removeFromParent(true);
                } else {
                    this.couldTouch = false;
                    this.allowEmulate();
                    this.body.applyImpulse(cp.v(this.deltaX,this.deltaY),cp.v(0,0));//提供一个瞬时的冲量
                    this.deltaX = 0;
                    this.deltaY = 0;
                }
                this._parent.hero_cloth_flag_have = false;
            }break;
            case "glass" :{
                if (this.isCollided(this._parent.hero_glass,this)) {
                    this.setPosition(this.prop_ok_pos);
                    this.setVisible(false);
                    if(this.currenthero == "duck") {
                        this._parent.hero_glass_index = findSkinIndex_string_duck("glass", this.getName().replace("glass_", ""));
                    }else{
                        this._parent.hero_glass_index = findSkinIndex_string("glass", this.getName().replace("glass_", ""));
                    }
                    // cc.log("当前的眼镜是 " + Config_Play.glass.names[revMapStr(this._parent.hero_glass_index)]);
                    this._parent.setSkin();
                    // this.checkCheerUp(this._parent.getHatIndexString(),this._parent.getGlassIndexString(),this._parent.getClothIndexString());
                    ddStopAllEffects();
                    ddPlayEffect("effect","res/K/audio/game/dressyes.mp3",false);
                    // this._parent.hero_glass_flag_have = false;
                    // if(!this._parent.hero_glass_flag_have) {
                    //     this._parent.propManagerGlass.gotoNextAndCreateAProp();
                    //     this._parent.hero_glass_flag_have = true;
                    // }
                    // this._parent.hero_glass_remove.setEnable(true);
                    if(this.currenthero == "duck"){
                        this._parent.hero_glass_flag_have = false;
                        if(!this._parent.hero_glass_flag_have) {
                            this._parent.propManagerGlass.gotoNextAndCreateAProp(Config_Play.glassduck.names[revMapStr(this._parent.hero_glass_index)]);
                            this._parent.hero_glass_flag_have = true;
                        }
                        this._parent.hero_glass_remove.setEnable(true);
                    }else{
                        this._parent.hero_glass_flag_have = false;
                        if(!this._parent.hero_glass_flag_have) {
                            this._parent.propManagerGlass.gotoNextAndCreateAProp(Config_Play.glass.names[revMapStr(this._parent.hero_glass_index)]);
                            this._parent.hero_glass_flag_have = true;
                        }
                        this._parent.hero_glass_remove.setEnable(true);
                    }


                    if(this.currenthero == "duck") {
                        var temp_a1 = Config_Play.hatduck.names[revMapStr(this._parent.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glassduck.names[revMapStr(this._parent.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.clothduck.names[revMapStr(this._parent.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }else{
                        var temp_a1 = Config_Play.hat.names[revMapStr(this._parent.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glass.names[revMapStr(this._parent.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.cloth.names[revMapStr(this._parent.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }

                    var a = temp_a1 + temp_a2 + temp_a3;
                    var b = this._parent.hero_hat_grade;
                    var c = 0;
                    var d = this._parent.hero_cloth_grade;
                    var e = 0;
                    var ind = 0;
                    for(var i = 0;i < this.configplay.hate.glass.length;i ++,ind ++){
                        if("glass_"+this.configplay.hate.glass[i] == target.name){
                            break;
                        }
                    }
                    if(ind == this.configplay.hate.glass.length){
                        e = this._parent.latestGrade = 1;
                        c = this._parent.hero_glass_grade = 1;
                    }else{
                        e = this._parent.latestGrade = -1;
                        c = this._parent.hero_glass_grade = -1;
                    }
                    this._parent.updateAndHandleUp(a,b,c,d,e);

                    this.removeFromParent(true);
                } else {
                    this.couldTouch = false;
                    this.allowEmulate();
                    this.body.applyImpulse(cp.v(this.deltaX,this.deltaY),cp.v(0,0));//提供一个瞬时的冲量
                    this.deltaX = 0;
                    this.deltaY = 0;
                }
                this._parent.hero_glass_flag_have = false;
            }break;
            case "hat" :{
                if (this.isCollided(this._parent.hero_hat,this)) {
                    this.setPosition(this.prop_ok_pos);
                    this.setVisible(false);
                    if(this.currenthero == "duck") {
                        this._parent.hero_hat_index = findSkinIndex_string_duck("hat", this.getName().replace("hat_", ""));
                    }else{
                        this._parent.hero_hat_index = findSkinIndex_string("hat", this.getName().replace("hat_", ""));
                    }
                    // cc.log("当前的帽子是 " + Config_Play.hat.names[revMapStr(this._parent.hero_hat_index)]);
                    this._parent.setSkin();
                    this.checkCheerUp(this._parent.getHatIndexString(),this._parent.getGlassIndexString(),this._parent.getClothIndexString());
                    // ddStopAllEffects();
                    ddPlayEffect("effect","res/K/audio/game/dressyes.mp3",false);
                    if(this.currenthero == "duck"){
                        this._parent.hero_hat_flag_have = false;
                        if(!this._parent.hero_hat_flag_have) {
                            this._parent.propManagerHat.gotoNextAndCreateAProp(Config_Play.hatduck.names[revMapStr(this._parent.hero_hat_index)]);
                            this._parent.hero_hat_flag_have = true;
                        }
                        this._parent.hero_hat_remove.setEnable(true);
                    }else{
                        this._parent.hero_hat_flag_have = false;
                        if(!this._parent.hero_hat_flag_have) {
                            this._parent.propManagerHat.gotoNextAndCreateAProp(Config_Play.hat.names[revMapStr(this._parent.hero_hat_index)]);
                            this._parent.hero_hat_flag_have = true;
                        }
                        this._parent.hero_hat_remove.setEnable(true);
                    }

                    if(this.currenthero == "duck") {
                        var temp_a1 = Config_Play.hatduck.names[revMapStr(this._parent.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glassduck.names[revMapStr(this._parent.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.clothduck.names[revMapStr(this._parent.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }else{
                        var temp_a1 = Config_Play.hat.names[revMapStr(this._parent.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glass.names[revMapStr(this._parent.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.cloth.names[revMapStr(this._parent.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }

                    var a = temp_a1 + temp_a2 + temp_a3;
                    var b = 0;
                    var c = this._parent.hero_glass_grade;
                    var d = this._parent.hero_cloth_grade;
                    var e = 0;
                    var ind = 0;
                    for(var i = 0;i < this.configplay.hate.hat.length;i ++,ind ++){
                        if("hat_"+this.configplay.hate.hat[i] == target.name){
                            break;
                        }
                    }
                    if(ind == this.configplay.hate.hat.length){
                        e = this._parent.latestGrade = 1;
                        b = this._parent.hero_hat_grade = 1;
                    }else{
                        e = this._parent.latestGrade = -1;
                        b = this._parent.hero_hat_grade = -1;
                    }
                    this._parent.updateAndHandleUp(a,b,c,d,e);

                    this.removeFromParent(true);
                } else {
                    this.couldTouch = false;
                    this.allowEmulate();
                    this.body.applyImpulse(cp.v(this.deltaX,this.deltaY),cp.v(0,0));//提供一个瞬时的冲量
                    this.deltaX = 0;
                    this.deltaY = 0;
                }
                this._parent.hero_hat_flag_have = false;
            }break;
            default:break;
        }
    },
    addTouchListener:function(){
        this.listener = registerTouchEventOneByOne(this,true);
    },
    removeShapeAndBody:function(){
        try{
            this._parent.space.removeBody(this.body);
            this._parent.space.removeShape(this.shape);
        }
        catch (error){
            cc.log("physics body and shape already be moved !!!")
        }
    },
    getPropType:function(targetname){
        if(isContains(targetname,"cloth")){
            return "cloth";
        }else if(isContains(targetname,"hat")){
            return "hat";
        }else if(isContains(targetname),"glass"){
            return "glass";
        }else{
            mylog("getPropType is nulltype");
            return "nulltype";
        }
    },
    checkCheerUp:function(hatidx,glassidx,clothidx){
        if(this.currenthero == "duck"){
            if(Config_Play.clothduck.names[revMapStr(clothidx)] == Config_Play.hatduck.names[revMapStr(hatidx)] && Config_Play.hatduck.names[revMapStr(hatidx)] == "shengdan"){
                //出现圣诞雪花飘落
                cc.log("出现圣诞雪花飘落1 " + GH);
                ddStopAllAudios();
                // ddPlayEffect("music","res/K/shengdan.mp3",false);
                cc.audioEngine.playMusic("res/K/shengdan.mp3",false);
                addSnow(this._parent,cc.p(GW2,GH));
            }
        }else{
            if(Config_Play.cloth.names[revMapStr(clothidx)] == Config_Play.hat.names[revMapStr(hatidx)] && Config_Play.hat.names[revMapStr(hatidx)] == "shengdan"){
                //出现圣诞雪花飘落
                cc.log("出现圣诞雪花飘落1 " + GH);
                ddStopAllAudios();
                cc.audioEngine.playMusic("res/K/shengdan.mp3",false);
                // ddPlayEffect("music","res/K/shengdan.mp3",false);
                addSnow(this._parent,cc.p(GW2,GH));
            }
        }
    },
    isCollided:function(nodeA,nodeB){
        cc.log("kkkkkk "+nodeA.x + "," + nodeA.y);
        cc.log("kkkkkk "+nodeB.x + "," + nodeB.y);
        if(Math.sqrt(Math.pow((nodeA.x - nodeB.x),2) + Math.pow(nodeA.y - nodeB.y,2)) <= 100){
            return true;
        }
        return false;
    },
    getName:function(){
        return this.name;
    }
});

function createSuperPropNode(currenthero,path,name,parent,position,zorder,mass,width,height,proptype,isnormal){
    var sprite = new SuperProp(currenthero,proptype,path,name,parent,mass,width,height,isnormal);
    sprite.setPosition(position);
    parent.addChild(sprite, zorder);

    return sprite;
}

var PropProperty = cc.Class.extend({
    currenthero:null,
    pathPrefex:null,
    parent:null,
    position:null,
    zorder:null,
    mass:null,
    width:null,
    height:null,
    proptype:null,
    proptypeName:null,
    ctor:function(currenthero,pathPrefex,parent,position,zorder,mass,width,height,proptype,proptypename){
        this.currenthero = currenthero;
        this.pathPrefex = pathPrefex;
        this.parent = parent;
        this.position = position;
        this.zorder = zorder;
        this.mass = mass;
        this.width = width;
        this.height = height;
        this.proptype = proptype;
        this.proptypeName = proptypename;
    }
});

var PropManager = cc.Node.extend({
    currentIndex:0,
    ctor:function(heroname,managername,circlearray,propProperty){
        this._super();
        this.isnormal = false;
        this.currentIndex = 0;
        this.heroname = heroname;
        this.managerName = managername;
        this.circleArray = circlearray;
        this.circleArray.reshuffle();

        this.propProperty = propProperty;
    },
    printCircleArray:function(){
        for(var i = 0;i < this.circleArray.length;i ++){
            cc.log(this.circleArray[i]);
        }
    },
    printProp:function(){
        cc.log(this.propProperty.currenthero);
        cc.log(this.propProperty.pathPrefex+this.propProperty.proptypeName+"/"+this.propProperty.proptypeName+"_"+this.circleArray[this.currentIndex]+".png");
        cc.log(this.circleArray[this.currentIndex]);
        cc.log(this.propProperty.parent);
        cc.log(this.propProperty.position);
        cc.log(this.propProperty.zorder);
        cc.log(this.propProperty.mass);
        cc.log(this.propProperty.width);
        cc.log(this.propProperty.height);
        cc.log(this.propProperty.proptype);
        cc.log(this.propProperty.proptypeName);
    },
    gotoNextAndCreateAProp:function(name){
        if(name == this.circleArray[this.currentIndex]) {
            this.currentIndex++;
            this.currentIndex = this.currentIndex % (this.circleArray.length);
        }
        this.createAProp();
    },
    createAProp:function(){
        var prop = createSuperPropNode(
            this.propProperty.currenthero,
            this.propProperty.pathPrefex+this.propProperty.proptypeName+"/"+this.propProperty.proptypeName+"_"+this.circleArray[this.currentIndex]+".png",
            this.propProperty.proptypeName+"_"+this.circleArray[this.currentIndex],
            this.propProperty.parent,
            this.propProperty.position,
            this.propProperty.zorder,
            this.propProperty.mass,
            this.propProperty.width,
            this.propProperty.height,
            this.propProperty.proptype,
            false
        );
        // this.printProp();
        // this.printCircleArray();
        prop.runAction(cc.sequence(
            cc.scaleTo(0.2,1.3,1.3).easing(cc.easeIn(1)),
            cc.scaleTo(0.2,1,1).easing(cc.easeOut(1))
        ));
        this.currentIndex ++;
        if(this.currentIndex == this.circleArray.length){
            this.circleArray.reshuffle();
        }
        this.currentIndex = this.currentIndex % (this.circleArray.length);

        switch (this.heroname){
            case "monkey":
                if(this.managerName == "HatManager"){
                    GlobalMonkeyLayer.hero_hat_flag_have = true;
                }else if(this.managerName == "GlassManager"){
                    GlobalMonkeyLayer.hero_glass_flag_have = true;
                }else if(this.managerName == "ClothManager"){
                    GlobalMonkeyLayer.hero_cloth_flag_have = true;
                }
                break;
            case "rabbit":
                if(this.managerName == "HatManager"){
                    GlobalRabbitLayer.hero_hat_flag_have = true;
                }else if(this.managerName == "GlassManager"){
                    GlobalRabbitLayer.hero_glass_flag_have = true;
                }else if(this.managerName == "ClothManager"){
                    GlobalRabbitLayer.hero_cloth_flag_have = true;
                }
                break;
            case "dog":
                if(this.managerName == "HatManager"){
                    GlobalDogLayer.hero_hat_flag_have = true;
                }else if(this.managerName == "GlassManager"){
                    GlobalDogLayer.hero_glass_flag_have = true;
                }else if(this.managerName == "ClothManager"){
                    GlobalDogLayer.hero_cloth_flag_have = true;
                }
                break;
            case "duck":
                if(this.managerName == "HatManager"){
                    GlobalDuckLayer.hero_hat_flag_have = true;
                }else if(this.managerName == "GlassManager"){
                    GlobalDuckLayer.hero_glass_flag_have = true;
                }else if(this.managerName == "ClothManager"){
                    GlobalDuckLayer.hero_cloth_flag_have = true;
                }
                break;
        }
        return prop;
    }
});