var GlobalRabbitLayer = null;
var RabbitLayer = cc.Layer.extend({
    sprite:null,
    ctor:function () {
        this._super();
        GlobalRabbitLayer = this;

        this.initGlobal();
        this.addBG();


        this.initPhysics();
        this.addEventManager();
        this.addPropManager();
        this.addTimerManager();

        this.scheduleOnce(function(){
            this.onEnterTransitionDidFinish1();
        }.bind(this),0.1);

        this.scheduleOnce(function(){
            GlobalADIndex++;
            if (recommandEnable() && AD_ENABLE && ARRY_AD_IN && ARRY_AD_IN.length) {
                GlobalADIndex = (GlobalADIndex++)  % ARRY_AD_IN.length;
                this.star_ad = new StarAdLayer(ARRY_AD_IN[GlobalADIndex]);
                this.star_ad.setGlobalZOrder(65535);
                this.star_ad.x = GW - 85;
                this.star_ad.y = - 15;
                this.addChild(this.star_ad, 65535);
            }
        }.bind(this),0.5);

        return true;
    },
    onExitTransitionDidStart:function(){
        ddStopAllAudios();
        cc.audioEngine.stopAllEffects();
        Config_Play.defaultSkin.rabbit.hat = this.hero_hat_index;
        Config_Play.defaultSkin.rabbit.glass = this.hero_glass_index;
        Config_Play.defaultSkin.rabbit.cloth = this.hero_cloth_index;
    },
    onEnterTransitionDidFinish1:function(){
        ddStopAllAudios();
        cc.audioEngine.stopAllEffects();
        this.addHero();
        this.addDebugNode();
        this.startGame();
    },
    addBG:function(){
        var back = new cc.Sprite("res/K/picture/scene/rabbit/background.png");
        back.setAnchorPoint(cc.p(0.5, 0));
        back.x = cc.winSize.width / 2;
        back.y = 0;
        this.addChild(back);

        back.scaleX = 1.2

        ddPlayEffect("effect","res/K/audio/game/enter.mp3",false);
        this.background = createStaticNode_AP("res/K/picture/scene/rabbit/beijing.png",this,cc.p(0+offsetX(),0),3,cc.p(0,0));
        this.guizidi = createStaticNode("res/K/picture/scene/rabbit/guizidi.png",this,cc.p(GW-195-offsetX(),283),1);
        this.yijia = createStaticNode("res/K/yijia.png",this,cc.p(GW-200-offsetX(),349),2);
    },
    initPhysics:function(){
        this.space = initPhysics(this);
        showDebug(this);
        this.scheduleUpdate();
    },
    addHero:function(){
        // this.hero = createSkeletonSprite("res/K/picture/scene/rabbit/skeleton.json","res/K/picture/scene/rabbit/skeleton.atlas",1,this,Config_Play.rabbit.hero_position,100);
        this.hero = createSkeletonSprite("res/spine/rabbit/skeleton.json","res/spine/rabbit/skeleton.atlas",1,this,cc.p(Config_Play.rabbit.hero_position.x,Config_Play.rabbit.hero_position.y*640/GH),100);
        // this.hero.setAnimation(1,"breath2",true);
        this.hero.setOpacity(0);

        this.hero.runAction(cc.fadeTo(0.1,255));
        this.hero.setSkin(findSkinByStr("kongbai","kongbai","kongbai"));
        this.initHero();

        //用于碰撞检测
        this.hero_cloth = createCustomLayerColor(this,10,10,cc.p(-3+GW2,180*640/GH),10000,"hero_cloth");
        this.hero_hat   = createCustomLayerColor(this,10,10,cc.p(-7+GW2,540*640/GH),10000,"hero_hat");
        this.hero_glass = createCustomLayerColor(this,10,10,cc.p(-7+GW2,360*640/GH),10000,"hero_glass");
        cc.log("rabbit hero_cloth " +this.hero_cloth.x+","+this.hero_cloth.y);
        cc.log("rabbit hero_hat " +this.hero_hat.x+","+this.hero_hat.y);
        cc.log("rabbit hero_glass " +this.hero_glass.x+","+this.hero_glass.y);


        this.hero_hat_index = Config_Play.defaultSkin.rabbit.hat;
        this.hero_glass_index = Config_Play.defaultSkin.rabbit.glass;
        this.hero_cloth_index = Config_Play.defaultSkin.rabbit.cloth;

        if(this.hero_hat_index == "9") {
            this.hero_hat_flag_have = false;
        }else{
            this.hero_hat_flag_have = true;
        }
        if(this.hero_glass_index == "4"){
            this.hero_glass_flag_have = false;
        }else{
            this.hero_glass_flag_have = true;
        }
        if(this.hero_cloth_index == "c"){
            this.hero_cloth_flag_have = false;
        }else{
            this.hero_cloth_flag_have = true;
        }
        this.setSkin();


        this.hero_love_hate_grade = 0;

        //fivecore abcde
        this.hero_dressedHatGlassClothCount = 0;//0 1 2 3//个数
        this.hero_hat_grade = 0;//-1 0 1//帽子分数
        this.hero_glass_grade = 0;//-1 0 1//眼镜分数
        this.hero_cloth_grade = 0;//-1 0 1//衣服分数
        this.latestGrade = 0;// -1 1    [0]//最后那个的分数


        //用于脱掉衣服检测
        this.hero_cloth_remove = createRemovePropLayerColor("rabbit","cloth",this.hero,180,150,cc.p(-3,-140),100,-1,GlobalRabbitLayer);//-1是默认啥都没穿
        this.hero_hat_remove = createRemovePropLayerColor("rabbit","hat",this.hero,240,120,cc.p(-7,180),100,-1,GlobalRabbitLayer);//-1是默认啥都没穿
        this.hero_glass_remove = createRemovePropLayerColor("rabbit","glass",this.hero,180,80,cc.p(-7,60),100,-1,GlobalRabbitLayer);//-1是默认啥都没穿

        if(this.hero_hat_index != "9") {
            this.hero_hat_remove.setEnable(true);
        }
        if(this.hero_glass_index != "4"){
            this.hero_glass_remove.setEnable(true);
        }
        if(this.hero_cloth_index != "c"){
            this.hero_cloth_remove.setEnable(true);
        }

        this.hero_all_touch = createTouchSpriteLayerColor("rabbit",this.hero,320,480,cc.p(-3,-10),200,this);

        this.filtercloth = createFilterEventLayerColor(this,Config_Play.filterSprite.cloth.width,Config_Play.filterSprite.cloth.height,Config_Play.rabbit.prop_position.cloth,10);
        this.filterhat = createFilterEventLayerColor(this,Config_Play.filterSprite.hat.width,Config_Play.filterSprite.hat.height,Config_Play.rabbit.prop_position.hat,10);
        this.filterglass = createFilterEventLayerColor(this,Config_Play.filterSprite.glass.width,Config_Play.filterSprite.glass.height,Config_Play.rabbit.prop_position.glass,10);
    },
    getHeroLoveHateGrade:function(){
        this.hero_love_hate_grade = this.hero_hat_grade + this.hero_glass_grade + this.hero_cloth_grade;
        return this.hero_love_hate_grade;
    },
    setHeroDressedHatGlassClothCount:function(count){//0 1 2 3
        this.hero_dressedHatGlassClothCount = count;
    },
    getHeroDressedHatGlassClothCount:function(){//0 1 2 3
        return this.hero_dressedHatGlassClothCount;
    },
    getLatestDressUpOrDownIsLove:function(){//最近脱掉或穿上的是否是喜欢的
        cc.log("this.lastGrade = " + this.latestGrade);
        if(this.latestGrade == -1) {
            return false;//不喜欢
        } else {
            return true;//最近那次喜欢
        }
    },
    setLastGrade:function(lastgrade){
        this.latestGrade = lastgrade;
    },
    getLastGrade:function(){
        return this.latestGrade;
    },
    //onecore
    updateAndHandleUp:function(a,b,c,d,e){
        cc.log(" ##### UP a = " + a +" , b = " + b +" , c = " + c +" , d " + d +" , e = " + e + "###########");
        this.updateFiveCore(a,b,c,d,e);
        this.handleDressUp();
    },
    updateAndHandleDown:function(a,b,c,d,e){
        cc.log(" ***** DW a = " + a +" , b = " + b +" , c = " + c +" , d " + d +" , e = " + e);
        this.updateFiveCore(a,b,c,d,e);
        this.handleDressDown();
    },
    //three core
    updateFiveCore:function(a,b,c,d,e){
        this.hero_dressedHatGlassClothCount = a;
        this.hero_hat_grade = b;
        this.hero_glass_grade = c;
        this.hero_cloth_grade = d;
        this.latestGrade = e;
    },
    handleDressUp:function(){//穿上
        this.timerManager.zeroDeltaSeconds();
        if(this.getLatestDressUpOrDownIsLove()){//如果最近一次是 喜欢
            if(1 == this.getHeroDressedHatGlassClothCount()){
                //随机love呼吸抖动
                this.randLove();
            }else if(this.getHeroDressedHatGlassClothCount() >= 2){
                //全喜欢 笑
                this.toLaugh();
            }
        }else{
            //最近穿上的是 讨厌
            if(1 == this.getHeroDressedHatGlassClothCount()){
                //随机hate呼吸抖动
                this.randHate();
            }else if(this.getHeroDressedHatGlassClothCount() >= 2){
                //全讨厌 哭
                this.toCry();
            }
        }
    },
    handleDressDown:function(){//脱掉
        this.timerManager.zeroDeltaSeconds();
        if(this.getLatestDressUpOrDownIsLove()){//最近脱掉的是 喜欢的
            cc.log("脱掉了喜欢的");
            if(0 == this.getHeroDressedHatGlassClothCount()){//只穿了一件,然后被脱了,不开心
                //随机hate呼吸抖动
                this.randHate();
            }else if(1 == this.getHeroDressedHatGlassClothCount()){//穿了两件,脱了一件喜欢的
                if(this.getHeroLoveHateGrade() == -1){//剩余的一件是讨厌的
                    //哭
                    this.toCry();
                }else{
                    //翻白眼
                    var idx = getRand0ToN(1);
                    if(0 == idx){
                        this.randHate();
                    }else{
                        this.toBaiyan();
                    }
                }
            }else if(2 == this.getHeroDressedHatGlassClothCount()){//穿了三件,脱了一件喜欢的
                if(this.getHeroLoveHateGrade() == -2){//剩余的两件都是讨厌的
                    //哭
                    this.toCry();
                }else{
                    //翻白眼
                    var idx = getRand0ToN(1);
                    if(0 == idx){
                        this.randHate();
                    }else{
                        this.toBaiyan();
                    }
                }
            }
        }else{
            cc.log("脱掉了讨厌的");
            //最近脱掉的是 讨厌的
            if(1 == this.getHeroDressedHatGlassClothCount()){
                //随机love呼吸抖动
                this.randLove();
            }else if(this.getHeroDressedHatGlassClothCount() >= 2){
                //全喜欢 笑
                this.toLaugh();
            }
        }
    },
    toCry:function(){
        var breathidx = this.getCurrentHeoBreathIdx();
        this.setHeroBreathsufAfterType(Config_Play.breathsufAfterType.cry);
        this.hero.setAnimation(1,"breath"+breathidx+" suf",false);
        this.timerManager.zeroDeltaSeconds();
    },
    toLaugh:function(){
        var breathidx = this.getCurrentHeoBreathIdx();
        this.setHeroBreathsufAfterType(Config_Play.breathsufAfterType.laugh);
        this.hero.setAnimation(1,"breath"+breathidx+" suf",false);
        this.timerManager.zeroDeltaSeconds();
    },
    toBaiyan:function(){
        ddStopAllEffects();
        ddPlayEffect("effect","res/K/audio/game/rabbit/baiyan.mp3",false);
        this.setHeroBreathsufAfterType(Config_Play.breathsufAfterType.shake);
        this.hero.setAnimation(1, 'breath12 suf', false);
        this.setCurrentHeoBreathIdx(12);
        this.timerManager.zeroDeltaSeconds();
    },
    randHate:function(){
        this.hero_breathsufaftertype = Config_Play.breathsufAfterType.shake;
        switch (getRand0ToN(5)){
            case 0:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/bugaoxing.mp3",false);
                this.hero.setAnimation(1, 'breath2 suf', true);
                this.setCurrentHeoBreathIdx(2);
                break;
            case 1:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/jingya.mp3",false);
                this.hero.setAnimation(1, 'breath3 suf', true);
                this.setCurrentHeoBreathIdx(3);
                break;
            case 2:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/pibei.mp3",false);
                this.hero.setAnimation(1, 'breath4 suf', true);
                this.setCurrentHeoBreathIdx(4);
                break;
            case 3:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/shengqi.mp3",false);
                this.hero.setAnimation(1, 'breath5 suf', true);
                this.setCurrentHeoBreathIdx(5);
                break;
            case 4:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/zhengzha.mp3",false);
                this.hero.setAnimation(1, 'breath6 suf', true);
                this.setCurrentHeoBreathIdx(6);
                break;
            case 5:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/baiyan.mp3",false);
                this.hero.setAnimation(1, 'breath12 suf', true);
                this.setCurrentHeoBreathIdx(12);
                break;
            default:
                break;
        }
        this.timerManager.zeroDeltaSeconds();
    },
    randLove:function(){
        this.hero_breathsufaftertype = Config_Play.breathsufAfterType.shake;
        switch (getRand0ToN(5)){
            case 0:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/weixiao.mp3",false);
                this.hero.setAnimation(1, 'breath1 suf', true);
                this.setCurrentHeoBreathIdx(1);
                break;
            case 1:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/xiyue.mp3",false);
                this.hero.setAnimation(1, 'breath7 suf', true);
                this.setCurrentHeoBreathIdx(7);
                break;
            case 2:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/gaoxing.mp3",false);
                this.hero.setAnimation(1, 'breath8 suf', true);
                this.setCurrentHeoBreathIdx(8);
                break;
            case 3:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/kaixing.mp3",false);
                this.hero.setAnimation(1, 'breath9 suf', true);
                this.setCurrentHeoBreathIdx(9);
                break;
            case 4:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/weixiao.mp3",false);
                this.hero.setAnimation(1, 'breath10 suf', true);
                this.setCurrentHeoBreathIdx(10);
                break;
            case 5:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/kaixing.mp3",false);
                this.hero.setAnimation(1, 'breath11 suf', true);
                this.setCurrentHeoBreathIdx(11);
                break;
            default:
                break;
        }
        this.timerManager.zeroDeltaSeconds();
    },

    addEventManager:function(){
        this.eventManager = new EventManagerNode();
        this.addChild(this.eventManager);
    },
    addTimerManager:function(){
        this.timerManager = new CustomTimerNode(10,function(){
            var breathidx = this.getCurrentHeoBreathIdx();
            this.setHeroBreathsufAfterType(Config_Play.breathsufAfterType.strech);
            this.hero.setAnimation(1,"breath"+breathidx+" suf",false);
        }.bind(this));
        this.addChild(this.timerManager);
    },
    enableHeroXRemove:function(){
        this.hero_cloth_remove.setEnable(true);
        this.hero_glass_remove.setEnable(true);
        this.hero_hat_remove.setEnable(true);
    },
    getHatIndexString:function(){
        return this.hero_hat_index;
    },
    getClothIndexString:function(){
        return this.hero_cloth_index;
    },
    getGlassIndexString:function(){
        return this.hero_glass_index;
    },
    setSkin:function(){
        this.hero.setSkin("skin"+this.hero_hat_index+this.hero_glass_index+this.hero_cloth_index);
    },
    setSkinByArg:function(a,b,c){
        this.hero.setSkin("skin"+a+b+c);
    },
    initGlobal:function(){
        // this.loveAnimationIdx = [1,7,8,9,10,11];
        // this.hateAnimationIdx = [2,3,4,5,6,12];
        // this.hateLoveIdx = [1,2,3,4,5,6,7,8,9,10,11,12];

        this.hero_breathIdx = 11;
        this.hero_breathsufaftertype = Config_Play.breathsufAfterType.notype;
    },
    setHeroBreathsufAfterType:function(type){
        this.hero_breathsufaftertype = type;
    },
    getHeroBreathsufAfterType:function(){
        return this.hero_breathsufaftertype;
    },
    addPropManager:function(){
        // this.cloth = createSuperPropNode("rabbit","res/K/picture/common/cloth/cloth_emo.png","cloth_emo",this,Config_Play.rabbit.prop_position.cloth,100,1,180,240,Config_Play.propType.cloth);
        // cc.log("cloth.group =   "+this.cloth.shape.group+" ,cloth.layers =  " +this.cloth.shape.layers);

        var propPropertyHat = new PropProperty("rabbit","res/K/picture/common/",this,Config_Play.rabbit.prop_position.hat,15,1,180,140,Config_Play.propType.hat,"hat");
        var propHatCircleArray = ["haidao","wuxia","xiaochou","mofa","shuishou","shengshi","chushi","emo","jingcha","mifeng","shengdan"];
        this.propManagerHat = new PropManager("rabbit","HatManager",propHatCircleArray,propPropertyHat);
        this.addChild(this.propManagerHat);

        var propPropertyGlass = new PropProperty("rabbit","res/K/picture/common/",this,Config_Play.rabbit.prop_position.glass,15,1,180,80,Config_Play.propType.glass,"glass");
        var propGlassCircleArray = ["taohua","laohua","mo","3d","baikuang"];
        this.propManagerGlass = new PropManager("rabbit","GlassManager",propGlassCircleArray,propPropertyGlass);
        this.addChild(this.propManagerGlass);

        var propPropertyCloth = new PropProperty("rabbit","res/K/picture/common/",this,Config_Play.rabbit.prop_position.cloth,2,1,180,180,Config_Play.propType.cloth,"cloth");
        var propClothCircleArray = ["gongzhu","haidao","wuxia","xiaochou","mofa","shuishou","tianshi","shengshi","chushi","emo","jingcha","niuzai","mifeng","shengdan"];
        this.propManagerCloth = new PropManager("rabbit","ClothManager",propClothCircleArray,propPropertyCloth);
        this.addChild(this.propManagerCloth);
    },
    addDebugNode:function(){
        addRetMenu(this, Config_Select.return_btn, this.backOperation);
        backKeyListenerAdd(this,this.backOperation);
    },
    backOperation:function(){
        GlobalSelectLayer.cameraMenu.couldEnter = true;
        ddStopAllAudios();
        cc.audioEngine.stopMusic();
        cc.director.popScene();
    },
    getCurrentHeoBreathIdx:function(){
        return this.hero_breathIdx;
    },
    setCurrentHeoBreathIdx:function(idx){
        this.hero_breathIdx = idx;
    },
    handleCompleteBreathSufListener:function(animationname,idx){
        if(animationname == "breath"+idx+" suf"){
            if(this.hero_breathsufaftertype == Config_Play.breathsufAfterType.shake){
                cc.log("aaa");
                this.hero.setAnimation(1,"shake"+idx,false);
            }else if(this.getHeroBreathsufAfterType() == Config_Play.breathsufAfterType.strech){
                var randidx = 1 + getRand0ToN(2);
                var breathidx = this.getCurrentHeoBreathIdx();
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/strech.mp3",false);
                this.hero.setAnimation(1,"strech"+randidx,false);
            }else if(this.getHeroBreathsufAfterType() == Config_Play.breathsufAfterType.cry){
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/rabbit/cry.mp3",false);
                this.hero.setAnimation(1,"cry",false);
            }else if(this.getHeroBreathsufAfterType() == Config_Play.breathsufAfterType.laugh){
                var clothidx = this.getClothIndexString();
                var hatidx = this.getHatIndexString();
                if(Config_Play.cloth.names[revMapStr(clothidx)] == Config_Play.hat.names[revMapStr(hatidx)] && Config_Play.hat.names[revMapStr(hatidx)] == "shengdan"){
                    //nothing
                }else {
                    ddStopAllEffects();
                }
                ddPlayEffect("effect","res/K/audio/game/rabbit/laugh.mp3",false);
                this.hero.setAnimation(1,"laugh",false);
            }
        }
    },
    handleCompleteStrechListener:function(animationname,idx){
        if(animationname == "strech"+idx){
            this.hero.setAnimation(1,"strech"+idx+" suf",false);
            this.timerManager.zeroDeltaSeconds();
        }
    },
    handleCompleteStrechSufListener:function(animationname,idx){
        if(animationname == "strech"+idx+" suf"){
            this.hero.setAnimation(1,"breath11",true);
            this.setCurrentHeoBreathIdx(11);
            this.timerManager.zeroDeltaSeconds();
        }
    },
    handleCompleteShakeListener:function(animationname,idx){
        if(animationname == "shake"+idx) {
            this.hero.setAnimation(1, 'breath' + idx, true);
            this.setCurrentHeoBreathIdx(idx);
            this.timerManager.zeroDeltaSeconds();
        }
    },
    handleCompleteLaughListener:function(animationame){
        if(animationame == "laugh") {
            this.hero.setAnimation(1, 'breath11', true);
            this.setCurrentHeoBreathIdx(11);
            this.timerManager.zeroDeltaSeconds();
        }
    },
    handleCompleteCryListener:function(animationame){
        if(animationame == "cry") {
            this.hero.setAnimation(1, 'breath10', true);
            this.setCurrentHeoBreathIdx(10);
            this.timerManager.zeroDeltaSeconds();
        }
    },
    initHero:function(){
        this.hero.setCompleteListener(function(trackEntry){
            if(trackEntry) {

                var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";

                if(animationName == "look around"){
                    GlobalRabbitLayer.hero.setAnimation(1,'breath11',true);
                    GlobalRabbitLayer.hero.hero_breathIdx = 11;
                }
                for(var idx = 1;idx <= 12;idx ++){
                    GlobalRabbitLayer.handleCompleteBreathSufListener(animationName,idx);
                    GlobalRabbitLayer.handleCompleteShakeListener(animationName,idx);
                }

                for(var i = 1;i <= 3; i ++){
                    GlobalRabbitLayer.handleCompleteStrechListener(animationName,i);
                    GlobalRabbitLayer.handleCompleteStrechSufListener(animationName,i);
                }

                GlobalRabbitLayer.handleCompleteLaughListener(animationName);
                GlobalRabbitLayer.handleCompleteCryListener(animationName);
            }
        });
    },
    update:function(dt){
        updatePhysics(this.space,dt);
    },
    collisionBegin:function(araiber,space){
        var shapeA = araiber.getShapes()[0];
        var shapeB = araiber.getShapes()[1];

        var bodyA = shapeA.getBody();
        var bodyB = shapeB.getBody();

        var spriteA = bodyA.datas;
        var spriteB = bodyB.datas;

        var shape = shapeA.collision_type == 1001 ? shapeA : shapeB;
        var body = shapeA.collision_type == 1001 ? bodyA : bodyB;
        var sprite = shapeA.collision_type == 1001 ? spriteA : spriteB;
        this.space.addPostStepCallback(function(){
            try{
                GlobalRabbitLayer.space.removeBody(body);
                GlobalRabbitLayer.space.removeShape(shape);
            }
            catch (error){
                cc.log("collisionBegin : already be moved !!!");
            }
            if(sprite){
                if(sprite.proptype == Config_Play.propType.cloth) {
                    if (!GlobalRabbitLayer.hero_cloth_flag_have && !sprite.isNormal) {
                        GlobalRabbitLayer.createSafePropCloth();
                        GlobalRabbitLayer.hero_cloth_flag_have = true;
                    } else {
                        GlobalRabbitLayer.hero_cloth_flag_have = false;
                    }
                }
                if(sprite.proptype == Config_Play.propType.glass) {
                    if (!GlobalRabbitLayer.hero_glass_flag_have && !sprite.isNormal) {
                        GlobalRabbitLayer.createSafePropGlass();
                        GlobalRabbitLayer.hero_glass_flag_have = true;
                    } else {
                        GlobalRabbitLayer.hero_glass_flag_have = false;
                    }
                }
                if(sprite.proptype == Config_Play.propType.hat) {
                    if (!GlobalRabbitLayer.hero_hat_flag_have && !sprite.isNormal) {
                        GlobalRabbitLayer.createSafePropHat();
                        GlobalRabbitLayer.hero_hat_flag_have = true;
                    } else {
                        GlobalRabbitLayer.hero_hat_flag_have = false;
                    }
                }
                sprite.removeFromParent(true);
                sprite = null;
            }
        });
        return false;
    },
    startGame:function(){
        cc.log("开始游戏");
        this.hero.setAnimation(1,'look around',false);
        this.hero_all_touch.setEnable(true);

        this.updateFiveCore(0,0,0,0,0);

        this.timerManager.startTimer();
        this.scheduleOnce(function(){
            ddPlayEffect("effect","res/K/audio/game/cloth_out.mp3",false);
            this.createSafePropCloth();
            this.filtercloth.isFilterEvent(false);
        }.bind(this),0.8);
        this.scheduleOnce(function(){
            ddPlayEffect("effect","res/K/audio/game/hat_out.mp3",false);
            this.createSafePropHat();
            this.filterhat.isFilterEvent(false);
        }.bind(this),1.1);
        this.scheduleOnce(function(){
            ddPlayEffect("effect","res/K/audio/game/glass_out.mp3",false);
            this.createSafePropGlass();
            this.filterglass.isFilterEvent(false);
        }.bind(this),1.4);
    },
    createSafePropCloth:function(){
        GlobalRabbitLayer.propManagerCloth.gotoNextAndCreateAProp(Config_Play.cloth.names[revMapStr(GlobalRabbitLayer.hero_cloth_index)]);
    },
    createSafePropGlass:function(){
        GlobalRabbitLayer.propManagerGlass.gotoNextAndCreateAProp(Config_Play.glass.names[revMapStr(GlobalRabbitLayer.hero_glass_index)]);
    },
    createSafePropHat:function(){
        GlobalRabbitLayer.propManagerHat.gotoNextAndCreateAProp(Config_Play.hat.names[revMapStr(GlobalRabbitLayer.hero_hat_index)]);
    }
});

var RabbitScene = cc.Scene.extend({
    customFlag:null,
    ctor:function () {
        this._super();
        this.customFlag = 0;
        umengEvent("animal_type", "Rabbit");
        var layer = new RabbitLayer();
        this.addChild(layer);
    }
});

