//传统帧
//一个动画：number图片的张数,prefix图片前缀,start--0从0开始或者1从1开始,ispng--0png1jpg,delayPerUnit每帧持续时间,obj运行动画的对象，times运行的次数,-1无限循环,resumeOriginFrame是否恢复到原始帧
function animationCreate(start,number,prefix,ispng,delayPerUnit,times,resumeOriginFrame){
    var animation = cc.Animation();
    animation.setDelayPerUnit(delayPerUnit);
    animation.setRestoreOriginalFrame(resumeOriginFrame);
    var suffix = null;
    (ispng) ? (suffix = ".png") : ( suffix = ".jpg");
    for(var i = start;i <= number;i ++ ){
        var fileName = prefix + i + suffix;
        animation.addSpriteFrameWithFile(fileName);
    }
    var animate = cc.animate(animation);
    if(-1 != times)
        var action = cc.repeat(animate, times);
    else
        var action = cc.repeatForever(animate);

    return animate;
}
//精灵帧
function newAnimationCreate(number,prefix,delayPerUnit,times,resumeOriginFrame) {
    var animation = cc.Animation();
    animation.setDelayPerUnit(delayPerUnit);
    if (typeof(resumeOriginFrame) == "undefined")
        resumeOriginFrame = true;
    animation.setRestoreOriginalFrame(resumeOriginFrame);
    var suffix = ".png";
    for (var i = 1; i <= number; i++) {
        var fileName = prefix + i + ".png";
        animation.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(fileName));
    }
    var animate = cc.animate(animation);
    if (-1 != times)
        var action = cc.repeat(animate, times);
    else
        var action = cc.repeatForever(animate);

    return action;
}

function createSkeletonSprite(json,atlas,scale,parent,position,zorder){
    var skeletonsprite = sp.SkeletonAnimation.createWithJsonFile(json,atlas,scale);
    skeletonsprite.setPosition(position);
    parent.addChild(skeletonsprite,zorder);

    return skeletonsprite;
}
function createSkeletonAnimation(json,atlas,scale,parent,position,zorder,priority,defaultanimation,iscircle){
    var skeletonsprite = createSkeletonSprite(json,atlas,scale,parent,position,zorder);
    skeletonsprite.setAnimation(priority,defaultanimation,iscircle);
    return skeletonsprite;
}

