function createStaticNode(path,parent,position,zorder){//不翻转
    cc.log("createStaticNode path is " + path);
    var sprite = new cc.Sprite(path);
    sprite.setPosition(position);
    parent.addChild(sprite, zorder);

    return sprite;
}
function createStaticNode_AP(path,parent,position,zorder,anchorpoint){//不翻转
    var sprite = createStaticNode(path,parent,position,zorder);
    sprite.setAnchorPoint(anchorpoint);
    return sprite;
}

function createStaticNode_Reverse(path,parent,position,zorder){//翻转
    var sprite = createStaticNode(path,parent,position,zorder);
    sprite.flippedX = true;

    return sprite;
}
function createStaticNode_Reverse_AP(path,parent,position,zorder,anchorpoint){//翻转
    var sprite = createStaticNode_Reverse(path,parent,position,zorder);
    sprite.setAnchorPoint(anchorpoint);

    return sprite;
}

var FilterEventLayerColor = cc.LayerColor.extend({
    isFilter:null,
    ctor:function(width,height){
        this._super(new cc.Color(255,255,0,255),width,height);
        this.isFilter = true;
        this.colorVisible(false);
        registerTouchEventOneByOne(this, true);
    },
    onTouchBegan: function (touch, event) {
        var target = event.getCurrentTarget();
        var locationInNode = target.convertToNodeSpace(touch.getLocation());
        var s = target.getContentSize();
        var rect = cc.rect(0, 0, s.width, s.height);
        var self = this;
        if (cc.rectContainsPoint(rect, locationInNode)) {
            return self.isFilter;
        }
        return false;
    },
    onTouchMoved:function(){

    },
    onTouchEnded:function(){

    },
    colorVisible:function(isVisible){
        if(isVisible){
            this.setOpacity(100);
        }else{
            this.setOpacity(0);
        }
    },
    isFilterEvent:function(isFilter){
        this.isFilter = isFilter;
    }
});
function createFilterEventLayerColor(parent,width,height,position,zorder){
    var sprite = new FilterEventLayerColor(width,height);
    sprite.setGlobalZOrder(10000);
    sprite.ignoreAnchorPointForPosition(false);
    sprite.setAnchorPoint(0.5,0.5);
    sprite.setPosition(position);
    parent.addChild(sprite, zorder);

    return sprite;
}

var customLayerColor = cc.LayerColor.extend({
    name:null,
    ctor:function(width,height,name){
        this._super(new cc.Color(0,0,255,255),width,height);
        this.name = name;
        this.colorVisible(true);
    },
    colorVisible:function(isVisible){
        if(isVisible){
            this.setOpacity(100);
        }else{
            this.setOpacity(0);
        }
    }
});
function createCustomLayerColor(parent,width,height,position,zorder,name){
    var sprite = new customLayerColor(width,height);
    sprite.ignoreAnchorPointForPosition(false);
    sprite.colorVisible(false);
    sprite.setAnchorPoint(0.5,0.5);
    sprite.setPosition(position);
    parent.addChild(sprite, zorder);

    return sprite;
}









var RemovePropLayerColor = cc.LayerColor.extend({
    currentDressed:null,
    isEnable:null,
    deltaX:null,
    deltaY:null,
    couldCreateOnce:null,
    sprite:null,
    hat:null,
    glass:null,
    cloth:null,
    configplay:null,
ctor:function(heroname,name,width,height,currentDressed,layer){
        this._super(new cc.Color(0,255,255,255),width,height);
        this.colorVisible(false);
        this.heroname = heroname;
        this.calcConfigplay();
        this.layer_ = layer;
        this.isEnable = true;
        this.deltaX = 0;
        this.deltaY = 0;
        this.name = name;
        this.calcDeltaParentPos();
        this.sprite_once = null;
        this.hat = null;
        this.glass = null;
        this.cloth = null;
        this.couldCreateOnce = true;
        this.currentDressed = currentDressed;
        this.calHeroOkPosition();
        registerTouchEventOneByOne(this, false);
    },
    calcConfigplay:function(){
        switch (this.heroname){
            case "monkey":
                this.configplay = Config_Play.monkey;
                break;
            case "rabbit":
                this.configplay = Config_Play.rabbit;
                break;
            case "dog":
                this.configplay = Config_Play.dog;
                break;
            case "duck":
                this.configplay = Config_Play.duck;
                break;
            default:
                break;
        }
    },
    calHeroOkPosition:function(){
        switch (this.heroname){
            case "monkey":
                this.hero_hat_ok_pos = Config_Play.monkey.prop_ok_position.hat;
                this.hero_glass_ok_pos = Config_Play.monkey.prop_ok_position.glass;
                this.hero_cloth_ok_pos = Config_Play.monkey.prop_ok_position.cloth;
                break;
            case "rabbit":
                this.hero_hat_ok_pos = Config_Play.rabbit.prop_ok_position.hat;
                this.hero_glass_ok_pos = Config_Play.rabbit.prop_ok_position.glass;
                this.hero_cloth_ok_pos = Config_Play.rabbit.prop_ok_position.cloth;
                break;
            case "dog":
                this.hero_hat_ok_pos = Config_Play.dog.prop_ok_position.hat;
                this.hero_glass_ok_pos = Config_Play.dog.prop_ok_position.glass;
                this.hero_cloth_ok_pos = Config_Play.dog.prop_ok_position.cloth;
                break;
            case "duck":
                this.hero_hat_ok_pos = Config_Play.duck.prop_ok_position.hat;
                this.hero_glass_ok_pos = Config_Play.duck.prop_ok_position.glass;
                this.hero_cloth_ok_pos = Config_Play.duck.prop_ok_position.cloth;
                break;
            default:
                break;
        }
    },
    calcDeltaParentPos:function(currenthero){
        switch (currenthero){
            case "rabbit" :
                this.deltaParentPos = Config_Play.rabbit.hero_position;
                break;
            case "duck" :
                this.deltaParentPos = Config_Play.duck.hero_position;
                break;
            case "monkey" :
                this.deltaParentPos = Config_Play.monkey.hero_position;
                break;
            case "dog" :
                this.deltaParentPos = Config_Play.dog.hero_position;
                break;
            default :
                this.deltaParentPos = cc.p(GW2,GH2);
                break;
        }
    },
    onTouchBegan: function (touch, event) {
        var target = event.getCurrentTarget();
        var locationInNode = target.convertToNodeSpace(touch.getLocation());
        var s = target.getContentSize();
        var rect = cc.rect(0, 0, s.width, s.height);
        var self = this;
        if (cc.rectContainsPoint(rect, locationInNode) && self.isEnable) {
            return true;
        }
        return false;
    },
    onTouchMoved:function(touch,event){
        var delta = touch.getDelta();
        this.deltaX += delta.x;
        this.deltaY += delta.y;

        var delta = touch.getDelta();
        this.deltaX += delta.x;
        this.deltaY += delta.y;
        this._idx = null;
        if(Math.sqrt(Math.pow(this.deltaX,2) + Math.pow(this.deltaY,2)) >= 5.0){
            this.createOnce();
        }

        if(this.sprite_once){
            this.sprite_once.x += delta.x;
            this.sprite_once.y += delta.y;
        }
    },
    onTouchEnded:function(touch,event){
        this.deltaX = 0;
        this.deltaY = 0;
        this.spr = null;
        this.prop_ok_pos = null;
        var self = this;
        switch (this.name){
            case "hat":
                this.spr = this.layer_.hero_hat;
                this.prop_ok_pos = this.configplay.prop_ok_position.hat;
                break;
            case "glass":
                this.spr = this.layer_.hero_glass;
                this.prop_ok_pos = this.configplay.prop_ok_position.glass;
                break;
            case "cloth":
                this.spr = this.layer_.hero_cloth;
                this.prop_ok_pos = this.configplay.prop_ok_position.cloth;
                break;
            default:
                break;
        }
        if(this.sprite_once && this.spr){
            if(this.isCollided(this.spr,this.sprite_once)){
                this.sprite_once.setPosition(this.prop_ok_pos);
                switch (this.name) {
                    case "hat":
                        if(this.heroname == "duck") {
                            this.hat = this.layer_.hero_hat_index = findSkinIndex_string_duck("hat", this.sprite_once.getName().replace("hat_", ""));
                        }else{
                            this.hat = this.layer_.hero_hat_index = findSkinIndex_string("hat", this.sprite_once.getName().replace("hat_", ""));
                        }
                        this.layer_.hero_hat_remove.setEnable(false);

                        break;
                    case "glass":
                        if(this.heroname == "duck") {
                            this.glass = this.layer_.hero_glass_index = findSkinIndex_string_duck("glass", this.sprite_once.getName().replace("glass_", ""));
                        }else{
                            this.glass = this.layer_.hero_glass_index = findSkinIndex_string("glass", this.sprite_once.getName().replace("glass_", ""));
                        }
                        this.layer_.hero_glass_remove.setEnable(false);

                        break;
                    case "cloth":
                        if(this.heroname == "duck") {
                            this.cloth = this.layer_.hero_cloth_index = findSkinIndex_string_duck("cloth", this.sprite_once.getName().replace("cloth_", ""));
                        }else{
                            this.cloth = this.layer_.hero_cloth_index = findSkinIndex_string("cloth", this.sprite_once.getName().replace("cloth_", ""));
                        }
                        this.layer_.hero_cloth_remove.setEnable(false);

                        break;
                }
                cc.log("设置皮肤");
                this.layer_.setSkin();
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/dressyes.mp3",false);

                switch (this.name) {
                    case "hat":
                        if(this.heroname == "duck"){
                            var temp_a1 = Config_Play.hatduck.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                            var temp_a2 = Config_Play.glassduck.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                            var temp_a3 = Config_Play.clothduck.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                        }else {
                            var temp_a1 = Config_Play.hat.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                            var temp_a2 = Config_Play.glass.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                            var temp_a3 = Config_Play.cloth.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                        }

                        var a = temp_a1 + temp_a2 + temp_a3;
                        var b = 0;
                        var c = this.layer_.hero_glass_grade;
                        var d = this.layer_.hero_cloth_grade;
                        var e = 0;
                        var ind = 0;
                        for(var i = 0;i < this.configplay.hate.hat.length;i ++,ind ++){
                            if("hat_"+this.configplay.hate.hat[i] == this.sprite_once.name){
                                break;
                            }
                        }
                        if(ind == this.configplay.hate.hat.length){
                            e = this.layer_.latestGrade = 1;
                            b = this.layer_.hero_hat_grade = 1;
                        }else{
                            e = this.layer_.latestGrade = -1;
                            b = this.layer_.hero_hat_grade = -1;
                        }
                        this.layer_.updateAndHandleUp(a,b,c,d,e);
                        break;
                    case "glass":
                        if(this.heroname == "duck") {
                            var temp_a1 = Config_Play.hatduck.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                            var temp_a2 = Config_Play.glassduck.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                            var temp_a3 = Config_Play.clothduck.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                        }else{
                            var temp_a1 = Config_Play.hat.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                            var temp_a2 = Config_Play.glass.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                            var temp_a3 = Config_Play.cloth.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                        }

                        var a = temp_a1 + temp_a2 + temp_a3;
                        var b = this.layer_.hero_hat_grade;
                        var c = 0;
                        var d = this.layer_.hero_cloth_grade;
                        var e = 0;
                        var ind = 0;
                        for(var i = 0;i < this.configplay.hate.glass.length;i ++,ind ++){
                            if("glass_"+this.configplay.hate.glass[i] == this.sprite_once.name){
                                break;
                            }
                        }
                        if(ind == this.configplay.hate.glass.length){
                            e = this.layer_.latestGrade = 1;
                            c = this.layer_.hero_glass_grade = 1;
                        }else{
                            e = this.layer_.latestGrade = -1;
                            c = this.layer_.hero_glass_grade = -1;
                        }
                        this.layer_.updateAndHandleUp(a,b,c,d,e);
                        break;
                    case "cloth":
                        if(this.heroname == "duck") {
                            var temp_a1 = Config_Play.hatduck.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                            var temp_a2 = Config_Play.glassduck.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                            var temp_a3 = Config_Play.clothduck.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                        }else{
                            var temp_a1 = Config_Play.hat.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                            var temp_a2 = Config_Play.glass.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                            var temp_a3 = Config_Play.cloth.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                        }

                        var a = temp_a1 + temp_a2 + temp_a3;
                        var b = this.layer_.hero_hat_grade;
                        var c = this.layer_.hero_glass_grade;
                        var d = 0;
                        var e = 0;
                        var ind = 0;
                        for(var i = 0;i < this.configplay.hate.cloth.length;i ++,ind ++){
                            if("cloth_"+this.configplay.hate.cloth[i] == this.sprite_once.name){
                                break;
                            }
                        }
                        if(ind == this.configplay.hate.cloth.length){
                            e = this.layer_.latestGrade = 1;
                            d = this.layer_.hero_cloth_grade = 1;
                        }else{
                            e = this.layer_.latestGrade = -1;
                            d = this.layer_.hero_cloth_grade = -1;
                        }
                        this.layer_.updateAndHandleUp(a,b,c,d,e);
                        break;
                    default:
                        break;
                }

                this.sprite_once.setPosition(this.prop_ok_pos);
                this.sprite_once.setVisible(false);
                this.sprite_once.couldTouch = false;
                this.isEnable = true;
                this.sprite_once.removeFromParent(true);
            }else{
                this.isEnable = false;
                this.sprite_once.allowEmulate();
                this.sprite_once.couldTouch = false;
                this.layer_.hero_hat_index = this.a;
                this.layer_.hero_glass_index = this.b;
                this.layer_.hero_cloth_index = this.c;
            }
            this.sprite_once = null;
            this.couldCreateOnce = true;
        }
    },
    isCollided:function(nodeA,nodeB){
        cc.log("kkkkkk "+nodeA.x + "," + nodeA.y);
        cc.log("kkkkkk "+nodeB.x + "," + nodeB.y);
        if(Math.sqrt(Math.pow((nodeA.x - nodeB.x),2) + Math.pow(nodeA.y - nodeB.y,2)) <= 100){
            return true;
        }
        return false;
    },
    createOnce:function(){
        if(this.couldCreateOnce){
            this._idx = null;
            this.couldCreateOnce = false;
            switch (this.name) {
                case "hat":
                    this._idx = this.layer_.getHatIndexString();
                    if(this.heroname == "duck") {
                        this.a = findSkinIndex_string_duck("hat", "kongbai");
                    }else{
                        this.a = findSkinIndex_string("hat", "kongbai");
                    }
                    this.b = this.layer_.getGlassIndexString();
                    this.c = this.layer_.getClothIndexString();

                    break;
                case "glass":
                    this._idx = this.layer_.getGlassIndexString();
                    this.a = this.layer_.getHatIndexString();
                    if(this.heroname == "duck") {
                        this.b = findSkinIndex_string_duck("glass", "kongbai");
                    }else{
                        this.b = findSkinIndex_string("glass", "kongbai");
                    }
                    this.c = this.layer_.getClothIndexString();

                    break;
                case "cloth":
                    this._idx = this.layer_.getClothIndexString();
                    this.a = this.layer_.getHatIndexString();
                    this.b = this.layer_.getGlassIndexString();
                    if(this.heroname == "duck") {
                        this.c = findSkinIndex_string_duck("cloth", "kongbai");
                    }else{
                        this.c = findSkinIndex_string("cloth", "kongbai");
                    }

                    break;
            }
            cc.log("设置皮肤 ARG");
            this.layer_.setSkinByArg( this.a, this.b, this.c);
            ddStopAllEffects();
            // ddPlayEffect("effect","res/K/audio/game/dressyes.mp3",false);

            switch (this.name){
                case "hat":
                    var hatindex = revMapStr(this._idx);
                    if(this.heroname == "duck") {
                        var str = Config_Play.hatduck.names[hatindex];
                    }else{
                        var str = Config_Play.hat.names[hatindex];
                    }
                    this.sprite_once = createSuperPropNode(this.heroname,"res/K/picture/common/hat/hat_"+str+".png","hat_"+str ,this.layer_,this.hero_hat_ok_pos,100,1,180,140,Config_Play.propType.hat,true);
                    this.sprite_once.couldTouch = false;
                    // this.sprite_once.setScale(1.08,1.08);
                    this.sprite_once.runAction(cc.sequence(
                        cc.scaleTo(0.1,1.1).easing(cc.easeIn(1))
                    ));

                    if(this.heroname == "duck") {
                        var temp_a1 = Config_Play.hatduck.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glassduck.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.clothduck.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }else{
                        var temp_a1 = Config_Play.hat.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glass.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.cloth.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }

                    var a = temp_a1 + temp_a2 + temp_a3;
                    var b = 0;
                    var c = this.layer_.hero_glass_grade;
                    var d = this.layer_.hero_cloth_grade;
                    var e = 0;
                    var ind = 0;
                    var temp = this._idx;
                    var templastgrade = this.layer_.getLastGrade();
                    var tempcount = this.layer_.getHeroDressedHatGlassClothCount() - 1;
                    if(this.heroname == "duck") {
                        for (var i = 0; i < this.configplay.hate.hat.length; i++, ind++) {
                            if (this.configplay.hate.hat[i] == Config_Play.hatduck[revMapStr(temp)]) {
                                break;
                            }
                        }
                    }else{
                        for (var i = 0; i < this.configplay.hate.hat.length; i++, ind++) {
                            if (this.configplay.hate.hat[i] == Config_Play.hat[revMapStr(temp)]) {
                                break;
                            }
                        }
                    }
                    if(ind == this.configplay.hate.hat.length){
                        e = this.layer_.latestGrade = 1;
                    }else{
                        e = this.layer_.latestGrade = -1;
                    }
                    ind = 0;
                    this.layer_.updateAndHandleDown(tempcount,b,c,d,templastgrade);
                    this.layer_.setLastGrade(e);
                    this.layer_.setHeroDressedHatGlassClothCount(a);

                    break;
                case "glass":
                    var glassindex = revMapStr(this._idx);
                    if(this.heroname == "duck") {
                        var str = Config_Play.glassduck.names[glassindex];
                    }else{
                        var str = Config_Play.glass.names[glassindex];
                    }
                    this.sprite_once = createSuperPropNode(this.heroname,"res/K/picture/common/glass/glass_"+str+".png","glass_"+str ,this.layer_,this.hero_glass_ok_pos,100,1,180,140,Config_Play.propType.glass,true);
                    this.sprite_once.couldTouch = false;
                    // this.sprite_once.setScale(1.08,1.08);
                    this.sprite_once.runAction(cc.sequence(
                        cc.scaleTo(0.1,1.1).easing(cc.easeIn(1))
                    ));

                    if(this.heroname == "duck") {
                        var temp_a1 = Config_Play.hatduck.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glassduck.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.clothduck.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }else{
                        var temp_a1 = Config_Play.hat.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glass.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.cloth.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }

                    var a = temp_a1 + temp_a2 + temp_a3;
                    var b = this.layer_.hero_hat_grade;
                    var c = 0;
                    var d = this.layer_.hero_cloth_grade;
                    var e = 0;
                    var ind = 0;
                    var temp = this._idx;
                    var templastgrade = this.layer_.getLastGrade();
                    var tempcount = this.layer_.getHeroDressedHatGlassClothCount() - 1;
                    if(this.heroname == "duck") {
                        for (var i = 0; i < this.configplay.hate.glass.length; i++, ind++) {
                            if (this.configplay.hate.glass[i] == Config_Play.glassduck[revMapStr(temp)]) {
                                break;
                            }
                        }
                    }else{
                        for (var i = 0; i < this.configplay.hate.glass.length; i++, ind++) {
                            if (this.configplay.hate.glass[i] == Config_Play.glass[revMapStr(temp)]) {
                                break;
                            }
                        }
                    }
                    if(ind == this.configplay.hate.glass.length){
                        e = this.layer_.latestGrade = 1;
                    }else{
                        e = this.layer_.latestGrade = -1;
                    }
                    ind = 0;
                    this.layer_.updateAndHandleDown(tempcount,b,c,d,templastgrade);
                    this.layer_.setLastGrade(e);
                    this.layer_.setHeroDressedHatGlassClothCount(a);

                    break;
                case "cloth":
                    var clothindex = revMapStr(this._idx);
                    if(this.heroname == "duck") {
                        var str = Config_Play.clothduck.names[clothindex];
                        this.sprite_once = createSuperPropNode(this.heroname,"res/K/picture/common/cloth/duck/cloth_"+str+".png","cloth_"+str ,this.layer_,this.hero_cloth_ok_pos,100,1,180,140,Config_Play.propType.cloth,true);
                    }else{
                        var str = Config_Play.cloth.names[clothindex];
                        this.sprite_once = createSuperPropNode(this.heroname,"res/K/picture/common/cloth/cloth_"+str+".png","cloth_"+str ,this.layer_,this.hero_cloth_ok_pos,100,1,180,140,Config_Play.propType.cloth,true);
                    }
                    this.sprite_once.couldTouch = false;
                    // this.sprite_once.setScale(1.08,1.08);
                    this.sprite_once.runAction(cc.sequence(
                        cc.scaleTo(0.1,1.1).easing(cc.easeIn(1))
                    ));

                    if(this.heroname == "duck") {
                        var temp_a1 = Config_Play.hatduck.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glassduck.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.clothduck.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }else{
                        var temp_a1 = Config_Play.hat.names[revMapStr(this.layer_.hero_hat_index)] == "kongbai" ? 0 : 1;
                        var temp_a2 = Config_Play.glass.names[revMapStr(this.layer_.hero_glass_index)] == "kongbai" ? 0 : 1;
                        var temp_a3 = Config_Play.cloth.names[revMapStr(this.layer_.hero_cloth_index)] == "kongbai" ? 0 : 1;
                    }

                    var a = temp_a1 + temp_a2 + temp_a3;
                    var b = this.layer_.hero_hat_grade;
                    var c = this.layer_.hero_glass_grade;
                    var d = 0;
                    var e = 0;
                    var ind = 0;
                    var temp = this._idx;
                    var templastgrade = this.layer_.getLastGrade();
                    var tempcount = this.layer_.getHeroDressedHatGlassClothCount() - 1;
                    if(this.heroname == "duck") {
                        for (var i = 0; i < this.configplay.hate.cloth.length; i++, ind++) {
                            if (this.configplay.hate.cloth[i] == Config_Play.clothduck[revMapStr(temp)]) {
                                break;
                            }
                        }
                    }else{
                        for (var i = 0; i < this.configplay.hate.cloth.length; i++, ind++) {
                            if (this.configplay.hate.cloth[i] == Config_Play.cloth[revMapStr(temp)]) {
                                break;
                            }
                        }
                    }
                    if(ind == this.configplay.hate.cloth.length){
                        e = this.layer_.latestGrade = 1;
                    }else{
                        e = this.layer_.latestGrade = -1;
                    }
                    ind = 0;
                    this.layer_.updateAndHandleDown(tempcount,b,c,d,templastgrade);
                    this.layer_.setLastGrade(e);
                    this.layer_.setHeroDressedHatGlassClothCount(a);


                    break;
                default:
                    break;
            }
        }
    },
    colorVisible:function(isVisible){
        if(isVisible){
            this.setOpacity(100);
        }else{
            this.setOpacity(0);
        }
    },
    getCurrentDressed:function(){
        return this.currentDressed;
    },
    setEnable:function(isenable){
        this.isEnable = isenable;
    }
});
function createRemovePropLayerColor(heroname,name,parent,width,height,position,zorder,currentDressed,layer){
    var sprite = new RemovePropLayerColor(heroname,name,width,height,currentDressed,layer);
    sprite.setEnable(false);
    sprite.setGlobalZOrder(50000);
    sprite.ignoreAnchorPointForPosition(false);
    sprite.setAnchorPoint(0.5,0.5);
    sprite.setPosition(position);
    parent.addChild(sprite, zorder);

    return sprite;
}











var TouchSpriteLayerColor = cc.LayerColor.extend({
    isEnable:null,
    idx:null,
    deltaX:null,
    deltaY:null,
    ctor:function(heroname,width,height,layer){
        this._super(new cc.Color(255,255,0,255),width,height);
        this.colorVisible(false);
        this.layer = layer;
        this.isEnable = true;
        this.idx = -1;
        this.deltaX = 0;
        this.deltaY = 0;
        this.heroname = heroname;
        this.listener = registerTouchEventOneByOne(this, false);
    },
    onTouchBegan: function (touch, event) {
        var target = event.getCurrentTarget();
        var locationInNode = target.convertToNodeSpace(touch.getLocation());
        var s = target.getContentSize();
        var rect = cc.rect(0, 0, s.width, s.height);
        var self = this;
        if (cc.rectContainsPoint(rect, locationInNode) && self.isEnable) {
            this.idx = 1;
            return true;
        }
        return false;
    },
    onTouchMoved:function(touch,event){
        var delta = touch.getDelta();
        this.deltaX += delta.x;
        this.deltaY += delta.y;
        if(Math.sqrt(Math.pow(this.deltaX,2) + Math.pow(this.deltaY,2)) > 3){
            this.idx = 0;
            cc.audioEngine.stopMusic();
        }else{
            this.idx = 1;
        }
    },
    onTouchEnded:function(touch,event){

        if(this.idx == 0){

        }else if(this.idx == 1){
            this.layer.timerManager.zeroDeltaSeconds();
            ddStopAllAudios();
            if(this.heroname == "duck"){
                if("" == this.layer.hero_breathIdx){
                    ddStopAllEffects();
                    ddPlayEffect("effect","res/K/audio/game/duck/bugaoxing.mp3",false);
                }else if(2 == this.layer.hero_breathIdx){
                    ddStopAllEffects();
                    ddPlayEffect("effect","res/K/audio/game/duck/shengqi.mp3",false);
                }else if(3 == this.layer.hero_breathIdx){
                    ddStopAllEffects();
                    ddPlayEffect("effect","res/K/audio/game/duck/bugaoxing.mp3",false);
                }else if(4 == this.layer.hero_breathIdx){
                    ddStopAllEffects();
                    ddPlayEffect("effect","res/K/audio/game/duck/baiyan.mp3",false);
                }
            }else{
                ddStopAllEffects();
                if(1 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/weixiao.mp3",false);
                }else if(2 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/bugaoxing.mp3",false);
                }else if(3 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/jingya.mp3",false);
                }else if(4 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/pibei.mp3",false);
                }else if(5 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/shengqi.mp3",false);
                }else if(6 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/zhengzha.mp3",false);
                }else if(7 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/xiyue.mp3",false);
                }else if(8 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/gaoxing.mp3",false);
                }else if(9 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/kaixing.mp3",false);
                }else if(10 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/weixiao.mp3",false);
                }else if(11 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/kaixing.mp3",false);
                }else if(12 == this.layer.hero_breathIdx){
                    ddPlayEffect("effect","res/K/audio/game/"+this.heroname+"/baiyan.mp3",false);
                }
            }
            this.layer.hero.setAnimation(1,'shake'+this.layer.hero_breathIdx,false);
//            this.layer.hero.setAnimation(1,'breath'+this.layer.hero_breathIdx + ' suf',false);
//            this.layer.setHeroBreathsufAfterType(Config_Play.breathsufAfterType.shake);
        }
        this.idx = -1;
        this.deltaX = 0;
        this.deltaY = 0;
    },
    colorVisible:function(isVisible){
        if(isVisible){
            this.setOpacity(100);
        }else{
            this.setOpacity(0);
        }
    },
    setEnable:function(isenable){
        this.isEnable = isenable;
    }
});
function createTouchSpriteLayerColor(heroname,parent,width,height,position,zorder,layer){
    var sprite = new TouchSpriteLayerColor(heroname,width,height,layer);
    sprite.setEnable(false);
    sprite.setGlobalZOrder(60000);
    sprite.ignoreAnchorPointForPosition(false);
    sprite.setAnchorPoint(0.5,0.5);
    sprite.setPosition(position);
    parent.addChild(sprite, zorder);


    return sprite;
}



var EventManagerNode = cc.Node.extend({
    ctor:function(){
        this._super();
        // this.registEvents();
    },
    registEvents:function(){
        this.handleEvent("eventname",function(){
        });
    },
    emitEvent:function(eventname,userdata){
        sendCustomEventAddUserData(eventname,userdata);
    },
    handleEvent:function(eventname,callback){
        recvCustomEvent(eventname,callback);
    }
});


function addSnow(parent,position){
    var size = cc.winSize;
    var particleSystem = new cc.ParticleSystem("res/K/snow1.plist");
    particleSystem.setAutoRemoveOnFinish(true);
    particleSystem.setPosition(position);
    particleSystem.setPositionType(cc.ParticleSystem.TYPE_GROUPED);
    parent.addChild(particleSystem, 100000);
    particleSystem.duration = getRand0ToN(2) + 2;
}




var TestPoint = cc.Sprite.extend({
    ctor:function(path){
        this._super(path);

        registerTouchEventOneByOne(this,true);
    },
    onTouchBegan:function(touch,event){
        var target = event.getCurrentTarget();
        var locationInNode = target.convertToNodeSpace(touch.getLocation());
        var s = target.getContentSize();
        var rect = cc.rect(0, 0, s.width, s.height);
        var self = this;
        if (cc.rectContainsPoint(rect, locationInNode)) {
            return true;
        }
        return false;
    },
    onTouchMoved:function(touch,event){
        var delta = touch.getDelta();
        this.x += delta.x;
        this.y += delta.y;
    },
    onTouchEnded:function(touch,event){
        cc.log("当前位置 : " + "( " + parseInt(this.x) + ", " + parseInt(this.y) + " )");
    }
});


function backKeyListenerAdd(parent,callback){
    var self = parent;
    cc.eventManager.addListener({
        event: cc.EventListener.KEYBOARD,
        onKeyReleased: function(keyCode, event) {
            if (keyCode == cc.KEY.back) {
                callback();
            }
            else if (keyCode == cc.KEY.menu) {

            }
        }}, self);
}